<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Standard library functions | Chi documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-chi.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-chi.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="..">Chi website</a></p>
    <div id="toctitle">
     Chi documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation.html">Home</a></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/index.html">Chi Tutorial</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/introduction.html">Introduction</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/introduction.html#chi-in-a-nutshell">Chi in a nutshell</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/introduction.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html">Data types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#booleans">Booleans</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#enumerations">Enumerations</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#numbers">Numbers</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#strings">Strings</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#tuple-types">Tuple types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#notation">Notation</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#operator">Operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/datatypes.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#lists">Lists</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#initialization">Initialization</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#sets">Sets</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#dictionaries">Dictionaries</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#custom-types">Custom types</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/datatypes.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-assignment-statement">The assignment statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-if-statement">The <code>if</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-while-statement">The <code>while</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#the-for-statement">The <code>for</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/statements.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/functions.html">Functions</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/functions.html#sorted-lists">Sorted lists</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/functions.html#sort">Sort</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/functions.html#insert">Insert</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/input-output.html">Input and output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#the-read-function">The <code>read</code> function</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#reading-from-a-file">Reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#the-write-statement">The <code>write</code> statement</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/input-output.html#writing-to-a-file">Writing to a file</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/stochastic-behavior.html">Modeling stochastic behavior</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/stochastic-behavior.html#distributions">Distributions</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#constant-distributions">Constant distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#discrete-distributions">Discrete distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#continuous-distributions">Continuous distributions</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#references">References</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#simulating-stochastic-behavior">Simulating stochastic behavior</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/stochastic-behavior.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/processes.html">Processes</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#a-single-process">A single process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#a-process-in-a-process">A process in a process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/processes.html#many-processes">Many processes</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/channels.html">Channels</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#a-channel">A channel</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#synchronization-channels">Synchronization channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#two-channels">Two channels</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#more-senders-or-receivers">More senders or receivers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#notes">Notes</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/channels.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/buffers.html">Buffers</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-one-place-buffer">A one-place buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-single-process-buffer">A single process buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#an-infinite-buffer">An infinite buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-token-buffer">A token buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#a-priority-buffer">A priority buffer</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/buffers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html">Servers with time</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#the-clock">The clock</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html#adding-time">Adding time</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#a-deterministic-system">A deterministic system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#a-stochastic-system">A stochastic system</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/servers.html#two-servers">Two servers</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#serial-system">Serial system</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tutorial/servers.html#parallel-systems">Parallel systems</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#assembly">Assembly</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/servers.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/conveyors.html">Conveyors</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#timers">Timers</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#a-conveyor">A conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#a-priority-conveyor">A priority conveyor</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/conveyors.html#exercises">Exercises</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/experiments.html">Simulations and experiments</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-finite-systems">Simulating finite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-infinite-systems">Simulating infinite systems</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/experiments.html#simulating-several-scenarios">Simulating several scenarios</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-visualization.html#the-svg-file-format">The SVG file format</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-visualization.html#visualization">Visualization</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tutorial/svg-example.html">SVG visualization example</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#buffer-visualization">Buffer visualization</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#vertical-coordinates-trickery">Vertical coordinates trickery</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#server-process">Server process</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#visualizing-the-server">Visualizing the server</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#copying-svg-elements">Copying SVG elements</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tutorial/svg-example.html#moving-svg-elements">Moving SVG elements</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">Chi Reference Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="globals.html">Global definitions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#enumeration-definitions">Enumeration definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#type-definitions">Type definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#constant-definitions">Constant definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#process-definitions">Process definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#model-definitions">Model definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#function-definitions">Function definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#experiment-definitions">Experiment definitions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="globals.html#formal-parameters">Formal parameters</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html">Statements</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#local-variables">Local variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#assignment-statement">Assignment statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#iterative-statements">Iterative statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#while-loop-statement">While loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#for-loop-statement">For loop statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#break-statement">Break statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#continue-statement">Continue statement</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="statements.html#choice-statement">Choice statement</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#sub-process-statements">Sub-process statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#run-and-start-statements">Run and start statements</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#finish-statement">Finish statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#communication-statements">Communication statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#send-statement">Send statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#receive-statement">Receive statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#select-statement">Select statement</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="statements.html#other-statements">Other statements</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#delay-statement">Delay statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#write-statement">Write statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#close-statement">Close statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#return-statement">Return statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#exit-statement">Exit statement</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="statements.html#pass-statement">Pass statement</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="expressions.html">Expressions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#typed-expressions">Typed expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#enumeration-value">Enumeration value</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#boolean-expressions">Boolean expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#integer-expressions">Integer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#real-number-expressions">Real number expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#string-expressions">String expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#list-expressions">List expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#set-expressions">Set expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#dictionary-expressions">Dictionary expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#tuple-expression">Tuple expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#file-handle-expressions">File handle expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#read-expression">Read expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#timer-expressions">Timer expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#channel-expressions">Channel expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#distribution-expressions">Distribution expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#process-expressions">Process expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#instance-expressions">Instance expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#matrix-expression">Matrix expression</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#cast-expressions">Cast expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#function-call-expressions">Function call expressions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="expressions.html#operator-priorities">Operator priorities</a></li>
        </ul></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Standard library functions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#integer-functions">Integer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#real-number-functions">Real number functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#string-functions">String functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#list-functions">List functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#set-functions">Set functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#dictionary-functions">Dictionary functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#timer-functions">Timer functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#file-functions">File functions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#process-instance-functions">Process instance functions</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="distributions.html">Distributions</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#constant-distributions">Constant distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#discrete-distributions">Discrete distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#continuous-distributions">Continuous distributions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="distributions.html#references">References</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html">Types</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html#elementary-types">Elementary types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#boolean-type">Boolean type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#integer-type">Integer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#real-type">Real type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#string-type">String type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#file-type">File type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#instance-type">Instance type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#timer-type">Timer type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#matrix-type">Matrix type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#void-type">Void type</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="types.html#container-types">Container types</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#list-type">List type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#set-type">Set type</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="types.html#dictionary-type">Dictionary type</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#tuple-type">Tuple type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#channel-type">Channel type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#distribution-type">Distribution type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#function-type">Function type</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="types.html#process-type">Process type</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="lexicals.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#comment">Comment</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexicals.html#names">Names</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="migration.html">Model migration</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="svg-visualization.html">SVG visualization</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#svg-interface">SVG interface</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="svg-visualization.html#visualization-modification-commands">Visualization modification commands</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/index.html">Chi Tool Manual</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html">Software operation</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/operation.html#compile-and-simulate">Compile and simulate</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#quick-simulate">Quick simulate</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#compile-only">Compile only</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#simulate-a-compiled-model">Simulate a compiled model</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/operation.html#terminating-a-simulation">Terminating a simulation</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../tool-manual/command-line.html">Command line options</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#simulator-options">Simulator options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#general-application-options">General application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../tool-manual/command-line.html#compiler-options">Compiler options</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../release-notes.html">Chi release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-7-0">Version 7.0</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-6-0-2024-12-20">Version 6.0 (2024-12-20)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../documentation.html">Chi documentation</a> &gt; <a class="breadcrumb" href="index.html">Chi Reference Manual</a> &gt; <span class="breadcrumb">Standard library functions</span>
   </div>
   <h2 id="standard-library-functions"><a class="anchor" href="#"></a>Standard library functions</h2>
   <div class="paragraph">
    <p>The Chi language has many general purpose functions available. They are organized by type and kind of use.</p>
   </div>
   <div class="ulist">
    <ul>
     <li>
      <p><a href="#integer-functions">Integer functions</a></p></li>
     <li>
      <p><a href="#real-number-functions">Real number functions</a></p></li>
     <li>
      <p><a href="#string-functions">String functions</a></p></li>
     <li>
      <p><a href="#list-functions">List functions</a></p></li>
     <li>
      <p><a href="#set-functions">Set functions</a></p></li>
     <li>
      <p><a href="#dictionary-functions">Dictionary functions</a></p></li>
     <li>
      <p><a href="distributions.html">Distributions</a></p></li>
     <li>
      <p><a href="#timer-functions">Timer functions</a></p></li>
     <li>
      <p><a href="#file-functions">File functions</a></p></li>
     <li>
      <p><a href="#process-instance-functions">Process instance functions</a></p></li>
    </ul>
   </div>
   <div class="sect3">
    <h3 id="integer-functions"><a class="anchor" href="#integer-functions"></a>Integer functions</h3>
    <div class="paragraph">
     <p>The following standard library functions on integers exist:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>int</code> <strong>abs</strong><code>(int val)</code></p>
       <div class="paragraph">
        <p>Return the absolute value of <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>sign</strong><code>(int val)</code></p>
       <div class="paragraph">
        <p>Return <code>-1</code> if val less than zero, <code>1</code> if val more than zero, and <code>0</code> otherwise.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>max</strong><code>(int a, b, ...)</code></p>
       <div class="paragraph">
        <p>Return the biggest value of the parameters.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>min</strong><code>(int a, b, ...)</code></p>
       <div class="paragraph">
        <p>Return the smallest value of the parameters.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="real-number-functions"><a class="anchor" href="#real-number-functions"></a>Real number functions</h3>
    <div class="paragraph">
     <p>The following standard library functions on real numbers exist:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>real</code> <strong>abs</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Return the absolute value of <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>sign</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Return <code>-1</code> if val less than zero, <code>1</code> if val more than zero, and <code>0</code> otherwise.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>max</strong><code>(real a, b, ...)</code></p>
       <div class="paragraph">
        <p>Return the biggest value of the parameters. Integer parameters are silently promoted to real.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>min</strong><code>(real a, b, ...)</code></p>
       <div class="paragraph">
        <p>Return the smallest value of the parameters. Integer parameters are silently promoted to real.</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>Conversion from real number to integer can be performed in three different ways.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>int</code> <strong>ceil</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Return smallest integer bigger or equal to <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>floor</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Return biggest integer less or equal to <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>round</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Round to nearest integer value (up if distance is <code>0.5</code>).</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>The following power and logarithmic functions exist.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>real</code> <strong>sqrt</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Return the square root of <code>val</code> (argument must be non-negative).</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>cbrt</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Return the cube root of <code>val</code> (<code>val^(1/3)</code>).</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>exp</strong><code>(real x)</code></p>
       <div class="paragraph">
        <p>Compute <code>e^x</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>ln</strong><code>(real x)</code></p>
       <div class="paragraph">
        <p>Compute the natural logarithm of <code>x</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>log</strong><code>(real x)</code></p>
       <div class="paragraph">
        <p>Compute the base-10 logarithm of <code>x</code>.</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>Finally, there are trigonometric functions available.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>real</code> <strong>cos</strong><code>(real a)</code></p>
       <div class="paragraph">
        <p>Cosine function of angle <code>a</code> (in radians).</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>sin</strong><code>(real angle)</code></p>
       <div class="paragraph">
        <p>Sine function of angle <code>a</code> (in radians).</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>tan</strong><code>(real angle)</code></p>
       <div class="paragraph">
        <p>Tangent function of angle <code>a</code> (in radians).</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>acos</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Arc cosine function of value <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>asin</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Arc sine function of value <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>atan</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Arc tangent function of value <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>cosh</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Hyperbolic cosine function of value <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>sinh</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Hyperbolic sine function of value <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>tanh</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Hyperbolic tangent function of value <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>acosh</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Inverse hyperbolic cosine function of value <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>asinh</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Inverse hyperbolic sine function of value <code>val</code>.</p>
       </div></li>
      <li>
       <p><code>real</code> <strong>atanh</strong><code>(real val)</code></p>
       <div class="paragraph">
        <p>Inverse hyperbolic tangent function of value <code>val</code>.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="string-functions"><a class="anchor" href="#string-functions"></a>String functions</h3>
    <div class="paragraph">
     <p>The following string functions exist in the standard library.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>int</code> <strong>size</strong><code>(string s)</code></p>
       <div class="paragraph">
        <p>Get the number of characters in string <code>s</code>.</p>
       </div></li>
      <li>
       <p><code>string</code> <strong>max</strong><code>(string a, b, ...)</code></p>
       <div class="paragraph">
        <p>Return the biggest string of the parameters.</p>
       </div></li>
      <li>
       <p><code>string</code> <strong>min</strong><code>(string a, b, ...)</code></p>
       <div class="paragraph">
        <p>Return the smallest string of the parameters.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="list-functions"><a class="anchor" href="#list-functions"></a>List functions</h3>
    <div class="paragraph">
     <p>Getting an element out of list can be done in two ways.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>tuple(T value, list T ys)</code> <strong>pop</strong><code>(list T xs)</code></p>
       <div class="paragraph">
        <p>Get the first element of non-empty list <code>xs</code> (with arbitrary element type <code>T</code>), and return a tuple with the first element and the list without the first element.</p>
       </div></li>
      <li>
       <p><code>list T</code> <strong>del</strong><code>(list T xs, int index)</code></p>
       <div class="paragraph">
        <p>Remove element <code>xs[index]</code> from list <code>xs</code> (with arbitrary type <code>T</code>). The index position must exist in the list. Returns a list without the removed element.</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>For getting information about the number of elements in a list, the following functions are available.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>bool</code> <strong>empty</strong><code>(list T xs)</code></p>
       <div class="paragraph">
        <p>Is list <code>xs</code> empty (for any element type <code>T</code>)? Returns <code>true</code> when <code>xs</code> contains no elements, and <code>false</code> when it has at least one element.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>size</strong><code>(list T xs)</code></p>
       <div class="paragraph">
        <p>Get the number of elements in list <code>xs</code> (for any element type <code>T</code>).</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>List functions mainly useful for using with a <code>for</code> statement (explained in <a href="statements.html#for-loop-statement">For loop statement</a>) follow next.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>list tuple(int index, T value)</code> <strong>enumerate</strong><code>(list T xs)</code></p>
       <div class="paragraph">
        <p>Construct a copy of the list <code>xs</code> with arbitrary element type <code>T</code>, with each element replaced by a tuple containing the index of the element as well as the element itself. For example, <code>enumerate(["a", "b"])</code> results in the list <code>[(0, "a"), (1, "b")]</code>.</p>
       </div></li>
      <li>
       <p><code>list int</code> <strong>range</strong><code>(int end)</code></p>
       <div class="paragraph">
        <p>Construct a list with integer values running from <code>0</code> to (but not including) <code>end</code>. For example <code>range(3)</code> produces list <code>[0, 1, 2]</code>.</p>
       </div></li>
      <li>
       <p><code>list int</code> <strong>range</strong><code>(int start, end)</code></p>
       <div class="paragraph">
        <p>Construct a list with integer values running from <code>start</code> to (but not including) <code>end</code>. For example, <code>range(3, 7)</code> produces list <code>[3, 4, 5, 6]</code>.</p>
       </div></li>
      <li>
       <p><code>list int</code> <strong>range</strong><code>(int start, end, step)</code></p>
       <div class="paragraph">
        <p>Construct a list with integer values running from <code>start</code> to (but not including) <code>end</code>, while incrementing the value with step size <code>step</code>. For example <code>range(3, 8, 2)</code> produces <code>list [3, 5, 7]</code>. Negative step sizes are also allowed to construct lists with decrementing values, but <code>start</code> has to be larger than <code>end</code> in that case.</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>For occasionally getting the biggest or smallest element of a list, the <code>min</code> and <code>max</code> functions are available. These functions take a lot of time, if smallest or biggest values are needed often, it may be better to use a sorted list.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>T</code> <strong>min</strong><code>(list T xs)</code></p>
       <div class="paragraph">
        <p>Return the smallest element value of type <code>T</code> (<code>T</code> must be type int, real, or string) from non-empty list <code>xs</code>.</p>
       </div></li>
      <li>
       <p><code>T</code> <strong>max</strong><code>(list T xs)</code></p>
       <div class="paragraph">
        <p>Return the biggest element value of type <code>T</code> (<code>T</code> must be type int, real, or string) from non-empty list <code>xs</code>.</p>
       </div></li>
      <li>
       <p><code>list</code> <code>T</code> <strong>sort</strong><code>(list T xs, func bool pred(T a, b))</code></p>
       <div class="paragraph">
        <p>Sort list <code>xs</code> such that the predicate function <code>pred</code> holds for every pair of elements in the list, and return the sorted list.</p>
       </div>
       <div class="paragraph">
        <p>The predicate function <code>pred</code> must implement a total ordering on the values. See also the <a href="../tutorial/functions.html#sorted-lists">sorted lists</a> discussion in the tutorial.</p>
       </div></li>
      <li>
       <p><code>list</code> <code>T</code> <strong>insert</strong><code>(list T xs, T x, func bool pred(T a, b))</code></p>
       <div class="paragraph">
        <p>Given an already sorted list <code>xs</code> with respect to predicate function <code>pred</code> (with arbitrary element type <code>T</code>), insert element value <code>x</code> into the list such that the predicate function <code>pred</code> again holds for every pair of elements in the list. Return the list with the inserted <code>element</code>.</p>
       </div>
       <div class="paragraph">
        <p>The predicate function <code>pred</code> must implement a total ordering on the values. See also the <a href="../tutorial/functions.html#sorted-lists">sorted lists</a> discussion in the tutorial.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="set-functions"><a class="anchor" href="#set-functions"></a>Set functions</h3>
    <div class="paragraph">
     <p>Similar to lists, there are two functions for getting an element from a set.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>tuple(T val, set T yr)</code> <strong>pop</strong><code>(set T xr)</code></p>
       <div class="paragraph">
        <p>Get an element of non-empty set <code>xr</code> (with arbitrary element type <code>T</code>), and return a tuple with the retrieved element and the set without the retrieved element. Note that the order of elements in a set has no meaning, and may change at any moment.</p>
       </div></li>
      <li>
       <p><code>list tuple(int index, T val)</code> <strong>enumerate</strong><code>(set T xr)</code></p>
       <div class="paragraph">
        <p>Construct a list of tuples with position <code>index</code> and element value <code>val</code> from the set <code>xr</code> with arbitrary element type <code>T</code>. Note that the <code>index</code> has no meaning in the set.</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>Removing a single element from a set can be done with the function below.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>set T</code> <strong>del</strong><code>(set T xr, T value)</code></p>
       <div class="paragraph">
        <p>Remove from set <code>xr</code> (with arbitrary element type <code>T</code>) element <code>value</code> if it exists in the set. Returns a set without the (possibly) removed element.</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>For getting information about the number of elements in a set, the following functions are available.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>bool</code> <strong>empty</strong><code>(set T xr)</code></p>
       <div class="paragraph">
        <p>Is set <code>xr</code> empty (for any element type <code>T</code>)? Returns <code>true</code> when <code>xr</code> contains no elements, and <code>false</code> when it has at least one element.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>size</strong><code>(set T xr)</code></p>
       <div class="paragraph">
        <p>Get the number of elements in set <code>xr</code> (for any element type <code>T</code>).</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>For occasionally getting the biggest or smallest element of a set, the <code>min</code> and <code>max</code> functions are available. These functions take a lot of time, if smallest or biggest values are needed often, it may be better to make a sorted list.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>T</code> <strong>min</strong><code>(set T xr)</code></p>
       <div class="paragraph">
        <p>Return the smallest element value of type <code>T</code> (<code>T</code> must be type <code>int</code>, <code>real</code>, or <code>string</code>) from non-empty set <code>xr</code>.</p>
       </div></li>
      <li>
       <p><code>T</code> <strong>max</strong><code>(set T xr)</code></p>
       <div class="paragraph">
        <p>Return the biggest element value of type <code>T</code> (<code>T</code> must be type <code>int</code>, <code>real</code>, or <code>string</code>) from non-empty set <code>xr</code>.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="dictionary-functions"><a class="anchor" href="#dictionary-functions"></a>Dictionary functions</h3>
    <div class="paragraph">
     <p>Getting a value or a sequence of values from a dictionary can be done with the following functions.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>tuple(K key, V val, dict(K:V) e)</code> <strong>pop</strong><code>(dict(K:V) d)</code></p>
       <div class="paragraph">
        <p>Get a key-value pair from non-empty dictionary <code>d</code> (with arbitrary key type <code>K</code> and arbitrary value type <code>V</code>), and return a tuple with the retrieved key, the retrieved value, and the dictionary without the retrieved element.</p>
       </div></li>
      <li>
       <p><code>list tuple(int index, K key, V val)</code> <strong>enumerate</strong><code>(dict(K:V) d)</code></p>
       <div class="paragraph">
        <p>Construct a list of tuples with position <code>index</code>, key <code>key</code> and value <code>val</code> from dictionary <code>d</code> (with arbitrary key type <code>K</code> and arbitrary value type <code>V</code>). Note that the <code>index</code> has no meaning in the dictionary. In combination with a for statement (explained in <a href="statements.html#for-loop-statement">For loop statement</a>), it is also possible to iterate over the dictionary directly.</p>
       </div></li>
      <li>
       <p><code>list K</code> <strong>dictkeys</strong><code>(dict(K:V) d)</code></p>
       <div class="paragraph">
        <p>Return the keys of dictionary <code>d</code> (with any key type <code>K</code> and value type <code>V</code>) as a list with element type <code>K</code>. Since a dictionary has no order, the order of the elements in the resulting list is also undefined.</p>
       </div></li>
      <li>
       <p><code>list V</code> <strong>dictvalues</strong><code>(dict(K:V) d)</code></p>
       <div class="paragraph">
        <p>Return the values of dictionary <code>d</code> (with any key type <code>K</code> and value type <code>V</code>) as a list with element type <code>V</code>. Since a dictionary has no order, the order of the elements in the resulting list is also undefined.</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>Removing a single element from a dictionary can be done with the function below.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>dict(K:V)</code> <strong>del</strong><code>(dict(K:V) d, K key)</code></p>
       <div class="paragraph">
        <p>Remove element <code>key</code> from dictionary <code>d</code> (with arbitrary element key type <code>K</code> and arbitrary value type <code>V</code>) if it exists in the dictionary. Returns a dictionary without the (possibly) removed element.</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>The number of keys in a dictionary can be queried with the following functions.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>bool</code> <strong>empty</strong><code>(dict(K:V) d)</code></p>
       <div class="paragraph">
        <p>Is dictionary <code>d</code> empty? (with any key type <code>K</code> and value type <code>V</code>) Returns <code>true</code> when <code>d</code> contains no elements, and <code>false</code> when it has at least one key element.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>size</strong><code>(dict(K:V) d)</code></p>
       <div class="paragraph">
        <p>Get the number of key elements in dictionary <code>d</code> (with any key type <code>K</code> and value type <code>V</code>).</p>
       </div></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>For occasionally getting the biggest or smallest key value of a dictionary, the <code>min</code> and <code>max</code> functions are available. These functions take a lot of time, if smallest or biggest keys are needed often, it may be better to use a sorted list.</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p><code>K</code> <strong>min</strong><code>(dict(K:V) d)</code></p>
       <div class="paragraph">
        <p>Return the smallest key of type <code>K</code> (<code>K</code> must be type <code>int</code>, <code>real</code>, or <code>string</code>) from non-empty dictionary <code>d</code>.</p>
       </div></li>
      <li>
       <p><code>K</code> <strong>max</strong><code>(dict(K:V) d)</code></p>
       <div class="paragraph">
        <p>Return the biggest key of type <code>K</code> (<code>K</code> must be type <code>int</code>, <code>real</code>, or <code>string</code>) from non-empty dictionary <code>d</code>.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="timer-functions"><a class="anchor" href="#timer-functions"></a>Timer functions</h3>
    <div class="ulist">
     <ul>
      <li>
       <p><code>bool</code> <strong>ready</strong><code>(timer t)</code></p>
       <div class="paragraph">
        <p>Return whether timer <code>t</code> has expired (or was never set). Returns <code>true</code> if the timer has reached <code>0</code> or was never set, and <code>false</code> if it is still running.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="file-functions"><a class="anchor" href="#file-functions"></a>File functions</h3>
    <div class="ulist">
     <ul>
      <li>
       <p><code>bool</code> <strong>eof</strong><code>(file handle)</code></p>
       <div class="paragraph">
        <p>For files that are read, this function tests whether the end of the file (EOF) has been reached. That is, it tests whether you have read the last value in the <code>file</code>.</p>
       </div>
       <div class="paragraph">
        <p>If the call returns <code>true</code>, there are no more values to read. If it returns <code>false</code>, another value is still available. For an example of how to use <code>eof</code> and <code>eol</code>, see <a href="../tutorial/input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a>.</p>
       </div></li>
      <li>
       <p><code>bool</code> <strong>eol</strong><code>(file handle)</code></p>
       <div class="paragraph">
        <p>For files that are read, this function tests whether the end of a line (EOL) has been reached. That is, it tests whether you have read the last value at the current line.</p>
       </div>
       <div class="paragraph">
        <p>If the call returns <code>true</code>, there are no more values to read at this line. If it returns <code>false</code>, another value can be read. For an example of how to use <code>eof</code> and <code>eol</code>, see <a href="../tutorial/input-output.html#advanced-reading-from-a-file">Advanced reading from a file</a>.</p>
       </div>
       <div class="paragraph">
        <p>Note that 'the same line' is applied only to the leading white space. It does not say anything about the number lines that a value itself uses. For example, you could spread a list or set with numbers over multiple lines.</p>
       </div></li>
      <li>
       <p><code>int</code> <strong>newlines</strong><code>(file handle)</code></p>
       <div class="paragraph">
        <p>For files that are read, this function returns how many lines down the next value can be found. It returns a negative number if the end of the file has been reached.</p>
       </div>
       <div class="paragraph">
        <p>For example, executing:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-chi hljs" data-lang="chi">int i;
file f = open("data.txt", "r");

i = read(f, int);
writeln("read %d, eol count is %d", i, newlines(f));
i = read(f, int);
writeln("read %d, eol count is %d", i, newlines(f));
i = read(f, int);
writeln("read %d, eol count is %d", i, newlines(f));
close(f);</code></pre>
        </div>
       </div>
       <div class="paragraph">
        <p>where "data.txt" contains:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-none hljs">123 345
789</code></pre>
        </div>
       </div>
       <div class="paragraph">
        <p>produces:</p>
       </div>
       <div class="listingblock">
        <div class="content">
         <pre class="highlightjs highlight"><code class="language-console hljs" data-lang="console">read 123, eol count is 0
read 345, eol count is 1
read 789, eol count is -1</code></pre>
        </div>
       </div>
       <div class="paragraph">
        <p>After reading <code>123</code>, the next integer is at the same line, which is <code>0</code> lines down. After reading <code>345</code>, the next value is at the next line, which is <code>1</code> line down. After reading the final value, a negative line count is returned to indicate lack of a next value.</p>
       </div>
       <div class="paragraph">
        <p>Note that 'number of lines down' is applied only to the leading white space. It does not say anything about the number lines that a value itself uses, a set of list could use several lines.</p>
       </div></li>
      <li>
       <p><code>file</code> <strong>open</strong><code>(string filename, string mode)</code></p>
       <div class="paragraph">
        <p>Open the file with name <code>filename</code> using access mode <code>mode</code>. When the access mode is <code>"r"</code>, the file should exist and is opened for reading. When the access mode is <code>"w"</code>, the file is either created or its previous contents is erased. There is no way to append output to an existing file.</p>
       </div>
       <div class="paragraph">
        <p>Notice that filename is a normal Chi string, which means that the <code>\</code> character needs to be escaped to <code>\\</code>. (That is, use a string like <code>"mydir\\myfile.txt"</code> to open the file with the name <code>myfile.txt</code> in directory (map) <code>mydir</code>.</p>
       </div>
       <div class="paragraph">
        <p>Alternatively, you may want to use the forward slash <code>/</code> instead as path component separator.</p>
       </div></li>
     </ul>
    </div>
   </div>
   <div class="sect3">
    <h3 id="process-instance-functions"><a class="anchor" href="#process-instance-functions"></a>Process instance functions</h3>
    <div class="ulist">
     <ul>
      <li>
       <p><code>bool</code> <strong>finished</strong><code>(inst p)</code></p>
       <div class="paragraph">
        <p>Return whether the process stored by process instance <code>p</code> has finished. Returns <code>true</code> when the process has finished, and <code>false</code> if it has not ended yet.</p>
       </div></li>
     </ul>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Chi documentation</span> | <span>Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation</span> | <span>version v7.0-M1</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>